#include "jserver.h"

udata js_users = NULL;

/* thread that flushes old users from memory */
void *js_users_main(void *arg)
{
    pth_event_t ev;

    log_debug(ZONE,"THREAD:USERS starting");

/* XXX write this yet
    ev = pth_event(PTH_EVENT_MSG,mp);

    while(1)
    {
        pth_wait(ev);
        loop through the users looking for stale ones and free them
        they are stale if they have no current sessions and the timestamp is older than some value
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
*/
}


/* locates user data record
 * looks in current list,
 * else looks in xdb and creates new entry
 * else returns NULL (not a user)
 */
udata js_user(char *user)
{
    pool p;
    udata cur, newu;

    if(user == NULL) return NULL;

    log_debug(ZONE,"js_user(%s)",user);

    for(cur = js_users; cur != NULL; cur = cur->next)
        if(j_strcmp(cur->user, user) == 0)
            return cur;
 
    log_debug(ZONE,"js_user not current");

    /* create a udata struct */
    p = pool_new();
    newu = pmalloc(p, sizeof(_udata));
    memset(newu, '\0', sizeof(_udata));
    newu->p = p;
    newu->user = pstrdup(p, user);

    if(!js_xdb_get(newu, NS_AUTH))
    { /* no password, no user! */
        pool_free(newu->p);
        return NULL;
    }

    newu->next = js_users;
    js_users = newu;
    return newu;
}

void js_users_exit(void)
{
    udata curu;
    session curs;

    /* tell all the sessions to exit */
    for(curu = js_users; curu != NULL; curu = curu->next)
        for(curs = curu->sessions; curs != NULL; curs = curs->next)
            js_session_end(curs, "Server Exiting");
}
